
#include <stdio.h>
#include <stdlib.h>

/*
	迭arr  ̸, left right   ε ̴.
	QuickSort Լ   迭 arr left right  Ѵ.
	Ĺ ̴.
*/
void QuickSort(int arr[], int left, int right);

/*
	迭arr  ̸, left right   ε ̴.
	Լ ϴ  Ǻ  ڸ ã  Ѵ.
	Լ ϰ  ڸ ã Ǻ ε ̴.
*/
int Partition(int arr[], int left, int right);

/*	迭  ε idx1 idx2 ִ  ȯ	*/
void Swap(int arr[], int idx1, int idx2);

void DisplayArr(int arr[], int arrLen);

int main(void)
{
	int arr[] = { 5,3,8,4,9,1,6,2,7 };
		
	int arrLen = sizeof(arr) / sizeof(int);

	/*	0 8 ε ͵ 	*/
	QuickSort(arr, 0, arrLen - 1);
	
	DisplayArr(arr, arrLen);

	return 0;
}

/*
	迭arr  ̸, left right   ε ̴.
	QuickSort Լ   迭 arr left right  Ѵ.
	Ĺ ̴.
*/
void QuickSort(int arr[], int left, int right)
{
	int pivot;		//	߽ 

	if (left < right)
	{
		/*	 
			Ǻ  ڸ ã´. Ǻ  ڸ ã, Ǻ ߽  Ǻ  
			 Ǻ ū  Ѵ.
		*/
		pivot = Partition(arr, left, right);

		/*	pivot ߽, left pivot - 1   	*/
		QuickSort(arr, left, pivot - 1);

		/*	pivot ߽, pivot + 1 right   	*/
		QuickSort(arr, pivot + 1, right);
	}
}

/*
	迭arr  ̸, left right   ε ̴.
	Լ ϴ  Ǻ  ڸ ã  Ѵ.
	Լ ϰ  ڸ ã Ǻ ε ̴.
*/
int Partition(int arr[], int left, int right)
{
	int pivot = arr[left];	//	   ʿ ġ ͸ Ǻ 

	int low = left + 1;		//	Ǻ   ʿ ġ  ε
	int high = right;		//	Ǻ   ʿ ġ  ε

	while (low <= high)
	{
		/*	Ǻ ū    low   ̵	*/
		while (arr[low] <= pivot && low <= right)
			low++;

		/*	Ǻ     high   ̵	*/
		while (arr[high] >= pivot && high >= (left + 1))
			high--;

		/*	low high Ǹ, low high Ű  ȯ ʴ´.	*/
		if ( low <= high )
			Swap(arr, low, high);
	}

	/*
		Ǻ high Ű  ȯϹǷν,
		Ǻ  ڸ ã.
		Ǻ ߽,  Ǻ   ϰ,  Ǻ ū  .
	*/
	Swap(arr, left, high);

	return high;			//	Ű Ǻ ε  
}

/*	迭  ε idx1 idx2 ִ  ȯ	*/
void Swap(int arr[], int idx1, int idx2)
{
	int temp = arr[idx1];
	arr[idx1] = arr[idx2];
	arr[idx2] = temp;
}

void DisplayArr(int arr[], int arrLen)
{
	int i;

	for (i = 0; i < arrLen; i++)
		printf("%d ", arr[i]);

	printf("\n");
}









